var capitalize = function(some_string) {
    if (some_string) {
        return some_string[0].toUpperCase() + some_string.substring(1).toLowerCase();
    } else {
        return("");
    }
};

var copy_with_fade = function(event) {
    var target = $(event.delegateTarget);
    var $temp = $("<input>");
    $("body").append($temp);
    $temp.val($(target).html()).select();
    document.execCommand("copy");
    $temp.remove();
    $(target).fadeTo(100, 0).delay(100).fadeTo(100, 1);
}

var load_more = function(target) {
    var next = target.attr("data-next")
    var href = new URL(window.location);
    href.searchParams.set('o', next);

    $.get( href, function( response, tmp, request ) {
        next_offset = request.getResponseHeader('O3-Next-Offset');
        if (next_offset == "None") {
            target.hide()
        } else {
            target.attr("data-next", next_offset)
        }
        $(".o3-data-table tbody").append(response)
    });
}

var update_price = function() {
    // update total price in order form
    var target = $(".item-unit_price .item-amount input");
    var price = target.val().replace(/,/g, "")
    var amount = $(".item-quantity input").val()
    var total = price * amount
    $(".item-total_price .item-amount input").val(total.toFixed(2))
}

$(function() {
  // Handler for .ready() called.

    $("#deformCancel").on("click", function(event) {
        window.location.href = "/";
    })

    $(".o3-pwd-visibility").on("click", function(event) {
        // handle password visibility
        var target = $(event.delegateTarget)
        var pwd = target.parent().children("input")
        if (pwd.attr("type") == "password") {
            target.removeClass("o3-pwd-dots");
            target.addClass("o3-pwd-text");
            pwd.attr("type", "text")
        } else {
            target.addClass("o3-pwd-dots");
            target.removeClass("o3-pwd-text");
            pwd.attr("type", "password")
        }
    });

    $(".o3-reg-username-source").on("keyup", function(event) {
        // automatic username creation
        var first_name = $(".o3-reg-firstname").val();
        var last_name =  $(".o3-reg-lastname").val();
        var user_name = capitalize(first_name) + capitalize(last_name)
        $(".o3-reg-username").val(user_name);
    });

    $(".o3-details").on("click", function(event){
        // handle detail visibility
        var target = $(event.delegateTarget)
        if (target.hasClass("o3-show-details")) {
            target.removeClass("o3-show-details");
            target.addClass("o3-hide-details");
            $(".o3-data-table").addClass("o3-data-hide-details")
        } else {
            target.addClass("o3-show-details");
            target.removeClass("o3-hide-details");
            $(".o3-data-table").removeClass("o3-data-hide-details")
        }
    });

    $("#o3-selectall").on("click", function(event) {
        // select all checkboxes
        var target = $(event.delegateTarget);
        var is_checked = target.is(':checked');
        $(".o3-multiple-selection").prop('checked', is_checked);
        if (is_checked) {
            $(".o3-on-select").fadeIn(100);
        } else {
            $(".o3-on-select").fadeOut(100);
        }
    });

    $(".o3-data-table").on("click", function(event) {
        // set visibility of edit multiples
        if ($(".o3-data-table .o3-multiple-selection:checked").length > 0) {
            $(".o3-on-select").fadeIn(100);
        } else {
            $(".o3-on-select").fadeOut(100);
        }
    });

    $(".o3-on-select .btn").on("click", function(event) {
        var target = $(event.delegateTarget);
        var action = target.attr("data-action");
        var form = $("#o3-multiple-form");
        form.attr("action", action);
        form.submit();
    });

    $(".o3-copy").on("click", function(event) {
        // copy to clipboard
        copy_with_fade(event);
    });

    $(".o3-confirmation").on("click", function(event) {
        // delete confirmation dialog
        var target = $(event.delegateTarget);
        var checkbox = $(target).find(".custom-control-input");
        var button = $(".o3-confirm-button");
        if (checkbox.is(':checked')) {
            button.prop('disabled', false);
            button.addClass("btn-danger")
            button.removeClass("btn-outline-danger")
        } else {
            button.prop('disabled', true);
            button.removeClass("btn-danger")
            button.addClass("btn-outline-danger")
        }
    });

    $(".o3-set-multi-status").on("click", function(event) {
        // set status to multiple items
        var target = $(event.delegateTarget);
        var selects = $(".o3-data-edit-multiple select");
        selects.val(target.attr("data-multi-value"))
    });

    $(".o3-back").on("click", function(event){
        // back button
        history.back();
        return false;
    });

    $(".item-unit_price .item-amount input").on("keyup", function(event) {
        update_price();
    });

    $(".item-quantity input").on("keyup", function(event) {
        update_price();
    });

    $(".item-unit_price .item-currency input").on("keyup", function(event) {
        // update total price currency in order form
        var target = $(event.delegateTarget);
        var value = target.val()
        $(".item-total_price .item-currency input").val(value)

    });

    $("label.o3-form-copy").on("click", function(event){
        // copy to clipboard
        var target = $(event.delegateTarget);
        var parent = target.parent()
        var input = parent.find(".form-control")
        var value = input.first().val()
        var $temp = $('<input>');
        $("body").append($temp);
        $temp.val(value).select();
        document.execCommand("copy");
        $temp.remove();
        $(target).fadeTo(100, 0).delay(100).fadeTo(100, 1);
        $(input).fadeTo(100, 0).delay(100).fadeTo(100, 1);

    });

    $("label.o3-form-copy").attr("title", "copy to clipboard");

    $(".o3-order-form .invalid-feedback").addClass("col-sm-9 offset-sm-3");

    $(".o3-vendor").on("blur", function(event) {
        // autocorrect vendor
        var target = $(event.delegateTarget);
        var input_value = target.val()
        var url = target.attr("data-url")
        $.post( url, { vendor: input_value }, function( data ) {
            var corrected_name = data["name"];
            if (data["found"]) {
                if (corrected_name.toLowerCase() !=  input_value.toLowerCase()) {
                    info = $('.o3-vendor-cancel')
                    if( info.length) {
                        info.find("a").text('"' + input_value + '"')
                    } else {
                        info = $('<span>');
                        info.addClass("o3-vendor-cancel col-sm-9 offset-sm-3 small text-secondary");
                        info.html('Use <a href="#">"' + input_value + '"</a> instead.');
                        target.parent().append(info);
                        link = info.find("a");
                        link.on("click", function() {
                            var link_text = link.text();
                            var vendor = link_text.substring(1, link_text.length-1);
                            target.val(vendor)
                            info.remove()
                            return false;
                        });
                    }
                } else {
                    var info = $('.o3-vendor-cancel');
                    info.remove();
                }
                target.val(corrected_name);
            } else {
                var info = $('.o3-vendor-cancel');
                info.remove();
            }
        });
    });

    $(".o3-add-new-order .item-cas_description input").on("keyup", function(event){
        var target = $(event.delegateTarget);
        var search = target.val().toLowerCase();
        var search_length = search.length;
        if (search == "") {
            $(".o3-consumables table tbody tr").each( function( index, element ){
                var row = $(element)
                var text_elm = row.find(".o3-consumable-cas .text-truncate");
                var pure_text = text_elm.text()
                text_elm.html(pure_text);
                row.show();
            });
        } else {
            $(".o3-consumables table tbody tr").each( function( index, element ){
                var row = $(element)
                var cas = row.attr("title").toLowerCase()
                var start = cas.indexOf(search);
                var display = (start !== -1)
                var text_elm = row.find(".o3-consumable-cas .text-truncate");
                var pure_text = text_elm.text()
                row.toggle(display)
                if (display) {
                    var head = pure_text.substring(0, start);
                    var center = pure_text.substring(start, start+search_length);
                    var tails = pure_text.substring(start+search_length, pure_text.length);
                    var new_html = head + '<span class="font-weight-bolder">' + center + "</span>" +  tails;
                    text_elm.html(new_html);
                }  else  {
                    text_elm.html(pure_text);
                }
            });
        }
    });

    $(".o3-consumable-category-filter").on("click", function(event) {
        var target = $(event.delegateTarget);
        var filter_category = target.attr("data-filter");
        if (filter_category == "all") {
            $(".o3-consumables table tbody tr").show();
        } else {
            $(".o3-consumables table tbody tr").each( function( index, element ){
                var row = $(element)
                var display = row.data("category") == filter_category;
                row.toggle(display)
            });
        }
        $(".o3-consumable-category-filter").removeClass("active");
        target.addClass("active");
        return false;
    });

    $(".o3-consumables table tbody tr").on("click", function(event) {
        var target = $(event.delegateTarget);
        var data_cas = target.attr("title");
        var data_category = target.attr("data-category");
        var data_catalog = target.attr("data-catalog");
        var data_vendor = target.attr("data-vendor");
        var data_size = target.attr("data-size");
        var data_price = target.attr("data-price");

        $(".item-cas_description input").val(data_cas);
        $(".item-category select").val(data_category);
        $(".item-catalog_nr input").val(data_catalog);
        $(".item-vendor input").val(data_vendor);
        $(".item-package_size input").val(data_size);
        $(".item-unit_price .item-amount input").val(data_price);

        update_price();

        $(".item-cas_description input").focus()
    });

    var infinite = new Waypoint.Infinite({
        element: $('.infinite-container')[0],
        onAfterPageLoad: function(items) {
            items.find(".o3-copy").on("click", function(event) {
                copy_with_fade(event);
            });
        }
    });
});
